


/*
Neue Version mit ATTiny im DIL gehuse mit 8 MHZ
*/

//LINKSANSCHLAG pwm1,1000 
//RECHTSSANSCHLAG pwm1,2000  23mS
// PWM1,1000 1MS
// PWM1,2000 2MS
/*
PWM werden im 16 Bit Timer mit OCR1A(B erzeugt
*/ 

/*

FUSES MIT 8 MHZ Quarz
Low=xFF   High=CB---- alt war xDF, ext = FF, lock = xxFF
watchdog, SPI = BODEN=2,7V ON
ALLE Hckchen WEG, !! Gepft !  Auer WDTON


1 = KEIN Hckchen 
CKDIV8 = 1
SUT1 SUT0 = 11
CKSEL 3/2/1/0 = 1111
WDTON = 0
BODLEVEL 2/1/0 = 111
EESAVE= =1
DWEN = 1
*/


/*
SO: Luft mit 8MHZ  ABER iM RC-OSC Ohne Quarz 
Hckchen: 
WDTON
SUT0 ( nicht sUT1 ) !!!   = 10
CKSEL0					= 0100
CKSEL1
 ( nicht CKSEL2 ) !!!
CKSEL3
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

///SYSINFO
#define DATUM		"19.11.2015"
//#define DATUM		"24.01.2014"
//#define FUNKTION	"Lambda Viertel Dual Servo V3 mit ATTiny2313"
#define FUNKTION	"DUAL Servo V4 mit ATTiny2313"
#define AUTOR		"Christof Ermer"
#define BAUDRATE	"1200"
//FUSE 16MHz BrownOut=> L=0xFF H=0xD9
//http://www.engbedded.com/fusecalc
// ORG NewChip Tiyn2313  FUSE  0x64 0xDF
// 

/*
ftoa braucht Speicher wie sau

libusb0.dll
http://www.avrfreaks.net/index.php?name=PNphpBB2&file=viewtopic&p=373283
!!!!!!!!!!!!!!
Unter Windows NT,2000,XP,Vista? braucht AVRDUDE einen Treiber
GIVEIO.SYS, um auf die Ports zugreifen zu knnen.
Du kannst den Treiber durch den Aufruf der Batchdatei
WinAVR\bin\install_giveio.bat installieren.



in PonyProg Hckcen Setzen
Bits in PDF sind umzudrehen 
eine 0(PDF) ist ein Hckchen setzen in PonyProg, 
eine 1(PDF) ist Kstchen frei, 

WDTON = V Watchdog timer oN
//4.3Volt 
Bodlevel 2 = X
Bodlevel 1 = V
Bodlevel 0 = V
#define UART_BAUD_RATE	9600
#define F_CPU	16000000
*/

/*
in io.h 
#elif defined (__AVR_ATtiny2313__)
#include <avr/iotn2313.h>
*/

#include <avr/io.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr\eeprom.h>	

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <compat\deprecated.h>

//#include <avr\twi.h> /* Note [1] */  // NEUE DATEIVERSION_STR BEUNTZEN
//#include <avr\signal.h> //#include <signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "main.h"		//with Hardware assigns
#include "uart.h"

#ifndef CTC1
#define CTC1 WGM12              // for compatibility with ATmega
#endif

void Wait100ms(void);

#ifdef USE_TOGGLE_FLAG
void ToggleTEST_BIT(uint8_t ucCnt);
#endif

#ifdef UART_USE_ENABLED
void UART_TXRX_Check(void);
void ResetRxBuff(void);
#endif

//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_VERSION[] PROGMEM = VERSION;
#ifdef TEXT_SERVICE_USE_ENABLED
void CheckOrder(char* pcStr);
void PrintCR(void);
#endif

// GLOBALE VARIABLEN 

#ifdef UART_USE_ENABLED
volatile char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
#endif
#ifdef TEXT_SERVICE_USE_ENABLED
//static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif


static uint32_t	gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
static uint8_t	gu8Mode;

#ifdef TIMERxTICK_USED
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
//SIGNAL( TIMER0_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( SIG_WDT_OVERFLOW  )
// *******************************************************************
{
sei();
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif


// *******************************************************************
void Wait100ms(void)
// *******************************************************************
{
uint8_t u8Z;
for(u8Z=0; u8Z < 100; u8Z++)
	{
	_delay_ms(1);
	wdt_reset(); 
	};
};


/*
SIGNAL( TIMER1_CAPT_vect  ) // von ICR1 = Top Value
// *******************************************************************
{
TCNT1 = 0;
};
*/

	
/*
int32_t Round(double fIn)
// **********************************************
{
return (int32_t)floor(fIn + 0.5);
};
*/

#ifdef USE_TOGGLE_FLAG
// ****************************************************************
void ToggleTEST_BIT(uint8_t ucCnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
uint8_t ucNN;
for(ucNN=0; ucNN < ucCnt; ucNN++)
	{
	SET_TESTBIT_MAC;
	_delay_us(1);
	CLR_TESTBIT_MAC;
	_delay_us(1);
	};
};
#endif


#ifdef UART_USE_ENABLED
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG
	if( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		uart_puts_p(PSTR("UartEr");
		uart_putc(13);
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10: // order!! from Terminal
				{
				break;
				};
			case 13: // order!! from Terminal
				{
#ifdef COMMANDS_ENABLED
				CheckOrder(gcaRxStr);
#endif				
//uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );//!! Init UART interface				
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
			//Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif



#ifdef UART_USE_ENABLED
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
while(!(uart_getc() & UART_NO_DATA)){}; 
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif


#ifdef COMMANDS_ENABLED

// *******************************************
void TxOk(void)
// *******************************************
{
uart_puts_p( PSTR("OK") );
uart_putc( 13 );
};

// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucStrEnd = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*	

strcpy_P(gcaStr, PSTR(",")); //HILFSWEISE gcaStr fr ","
if( (pStrTok = strtok_r( (pcStrOrder), gcaStr, &pucStrEnd)) != NULL)
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;	
	};
gsCmd.uiCmdVal_1 = 0;

if( (pStrTok = strtok_r( NULL, gcaStr, &pucStrEnd)) != NULL)//Hole nun einen Value nach "#3,COMMAND,VALUE
	{
	gsCmd.uiCmdVal_1 = atol( pStrTok );// Und dann TO long
	};

//===================================================================================


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("PING")))
	{
	uart_puts_p( PSTR("Pong") );
	uart_putc( 13 );
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))
	{
	uart_puts_p( PSTR("Plastik Box-Dual-Servo") );
	uart_putc( 13 );
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("PWM1")))
	{
	PWM_ENABLE();
	gu8Mode |= MODE_SERVOS_ACTIVE;
	OCR1A = gsCmd.uiCmdVal_1;
	gu32_Ticks = 0;
	
//uart_puts_p( PSTR("OCR1=") );uart_puts( utoa(OCR1A, gcaStr, 10) );uart_putc( 13 );
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("PWM2")))
	{	
	PWM_ENABLE();
	gu8Mode |= MODE_SERVOS_ACTIVE;
	OCR1B = gsCmd.uiCmdVal_1;
	gu32_Ticks = 0;
//uart_puts_p( PSTR("OCR2=") );uart_puts( utoa(OCR1B, gcaStr, 10) );uart_putc( 13 );
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("STAT1")))
	{
	uart_puts( ltoa( OCR1A, gcaStr, 10 ) );
	uart_putc( 13 );
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("STAT2")))
	{	
	uart_puts( ltoa( OCR1B, gcaStr, 10 ) );
	uart_putc( 13 );
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("PO")))
	{
	PWM_ENABLE();
	gu8Mode |= MODE_SERVOS_ACTIVE;
	gu32_Ticks = 0;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("PF")))
	{
	PWM_DISABLE();
	gu8Mode &= ~MODE_SERVOS_ACTIVE;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GETMODE")))
	{
	uart_puts( ltoa( gu8Mode, gcaStr, 10 ) );
	uart_putc( 13 );
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SMASO"))) // Set Mode AUTo SERVO OFF
	{
	gu8Mode |= MODE_SERVOS_POWERFALLBACK;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("cMASO"))) // CLEAR Mode AUTo SERVO ON
	{
	gu8Mode &= ~MODE_SERVOS_POWERFALLBACK;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("ICR")))
	{	
	ICR1 = gsCmd.uiCmdVal_1;	//ndert die frequenz / jetzt 50Hz
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("??")))
	{
	uart_puts_p( PSTR("Ping, PWM1/2,STAT1/2,GETMODE,SMASO,cMASO,TO,TF,ICR,??") );
	uart_putc( 13 );	
	};
	
ResetRxBuff();
 };
#endif


#

// *****************************************************
int main(void)
// *****************************************************
{
//static uint16_t uiNN;
//static uint32_t u32Now;
//static uint8_t u8Val;
//static uint16_t u16Val;
//INITS
//The global interrupt flag is maintained in the I bit of the status register (SREG).  
cli();
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//8Bit
DDRB = PORTB_DDRX_OUTMASK;
//PORTB = PORTB_PRESET_PULLMASK;
//7Bit
DDRD = PORTD_DDRX_OUTMASK;	
//PORTD = PORTD_PRESET_PULLMASK;

MCUCR |= _BV(PUD); // Pullup OFF
WDTCSR |= _BV(WDIE); // 62,5/Sekunde = 16mS

#ifdef UART_USE_ENABLED
ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU ));// !! Init UART interface
#endif
sei();

#ifdef  USE_TOGGLE_FLAG
INIT_TESTBIT_REG_MAC;
CLR_TESTBIT_MAC;
#endif

PWM_DISABLE();
ICR1 = PWM_TEILER_FUER50HZ; // Fixed Top Value  /20000U fr 8MHZ
OCR1A =  PWM1_DEFAULT_VAL;
OCR1B =  PWM2_DEFAULT_VAL;
//TCCR1A = COM1A1, COM1A0, COM1B1, COM1B0,-,-, WGM11, WGM10
//Clear OC1A/OC1B on CompareMatch  WGM11 , WGM10
//Fast PWM mode, Set OC1A/OC1B on TOP, WGM13:0 set to fats PWM
TCCR1A = _BV( COM1A1) | _BV( COM1B1) | _BV( WGM11 ); 

// TCCR1B = ICNC1,ICES1,-,WGM13,WGM12,CS12,CS11,CS10
//ClockSelect /8
TCCR1B =  _BV( WGM13 ) | _BV( WGM12 ) | _BV( CS11 );

//ClockSelect /0 aber mit /8 in FUSE  CKDIV8 hat Haekchen
//TCCR1B =  _BV( WGM13 ) | _BV( WGM12) | _BV(CS10);
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE

// ************ MAIN LOOP FOR EVER *********************
uart_puts_p( PSTR("Dual Servo") );
uart_putc( 13 );
Wait100ms();
uart_puts_p( PSTR("1200 BAUD") );
uart_putc( 13 );


gu32_Ticks = 0;
gu8Mode |= MODE_SERVOS_POWERFALLBACK;

for (;;)  /* loop forever */
	{	
	sei();
	wdt_reset();   //WATCHDOG!
	
	gu32_Ticks++; // Fortlaufend !! 

	if( (gu8Mode & MODE_SERVOS_POWERFALLBACK ) &&
			(gu8Mode & MODE_SERVOS_ACTIVE) &&
			(gu32_Ticks > 1000000UL) //1Million
		)
		{
		PWM_DISABLE();
		gu8Mode &= ~MODE_SERVOS_ACTIVE;
		};

#ifdef UART_USE_ENABLED	
	UART_TXRX_Check();
#endif
	}; // main   END END *************
};
// ******************* MAIN END ********************************************

